<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDeviceSettingBackupInfo ArrayType
 * @subpackage Arrays
 */
class ArrayOfDeviceSettingBackupInfo extends AbstractStructArrayBase
{
    /**
     * The DeviceSettingBackupInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\DeviceSettingBackupInfo[]
     */
    public $DeviceSettingBackupInfo;
    /**
     * Constructor method for ArrayOfDeviceSettingBackupInfo
     * @uses ArrayOfDeviceSettingBackupInfo::setDeviceSettingBackupInfo()
     * @param \CustomerManagement\StructType\DeviceSettingBackupInfo[] $deviceSettingBackupInfo
     */
    public function __construct(array $deviceSettingBackupInfo = array())
    {
        $this
            ->setDeviceSettingBackupInfo($deviceSettingBackupInfo);
    }
    /**
     * Get DeviceSettingBackupInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\DeviceSettingBackupInfo[]|null
     */
    public function getDeviceSettingBackupInfo()
    {
        return isset($this->DeviceSettingBackupInfo) ? $this->DeviceSettingBackupInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDeviceSettingBackupInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDeviceSettingBackupInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDeviceSettingBackupInfoForArrayConstraintsFromSetDeviceSettingBackupInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDeviceSettingBackupInfoDeviceSettingBackupInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfDeviceSettingBackupInfoDeviceSettingBackupInfoItem instanceof \CustomerManagement\StructType\DeviceSettingBackupInfo) {
                $invalidValues[] = is_object($arrayOfDeviceSettingBackupInfoDeviceSettingBackupInfoItem) ? get_class($arrayOfDeviceSettingBackupInfoDeviceSettingBackupInfoItem) : sprintf('%s(%s)', gettype($arrayOfDeviceSettingBackupInfoDeviceSettingBackupInfoItem), var_export($arrayOfDeviceSettingBackupInfoDeviceSettingBackupInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DeviceSettingBackupInfo property can only contain items of type \CustomerManagement\StructType\DeviceSettingBackupInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DeviceSettingBackupInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\DeviceSettingBackupInfo[] $deviceSettingBackupInfo
     * @return \CustomerManagement\ArrayType\ArrayOfDeviceSettingBackupInfo
     */
    public function setDeviceSettingBackupInfo(array $deviceSettingBackupInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($deviceSettingBackupInfoArrayErrorMessage = self::validateDeviceSettingBackupInfoForArrayConstraintsFromSetDeviceSettingBackupInfo($deviceSettingBackupInfo))) {
            throw new \InvalidArgumentException($deviceSettingBackupInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($deviceSettingBackupInfo) || (is_array($deviceSettingBackupInfo) && empty($deviceSettingBackupInfo))) {
            unset($this->DeviceSettingBackupInfo);
        } else {
            $this->DeviceSettingBackupInfo = $deviceSettingBackupInfo;
        }
        return $this;
    }
    /**
     * Add item to DeviceSettingBackupInfo value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\DeviceSettingBackupInfo $item
     * @return \CustomerManagement\ArrayType\ArrayOfDeviceSettingBackupInfo
     */
    public function addToDeviceSettingBackupInfo(\CustomerManagement\StructType\DeviceSettingBackupInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\DeviceSettingBackupInfo) {
            throw new \InvalidArgumentException(sprintf('The DeviceSettingBackupInfo property can only contain items of type \CustomerManagement\StructType\DeviceSettingBackupInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DeviceSettingBackupInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\DeviceSettingBackupInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\DeviceSettingBackupInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\DeviceSettingBackupInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\DeviceSettingBackupInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\DeviceSettingBackupInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DeviceSettingBackupInfo
     */
    public function getAttributeName()
    {
        return 'DeviceSettingBackupInfo';
    }
}
